/* iRiver iFP 7XX Emulator
   Copyright (C) 2005 Tomasz Malesinski <tmal@mimuw.edu.pl>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _LCD_H_
#define _LCD_H_

#include <stdio.h>

#include "emuriver.h"

#define LCD_WIDTH 132
#define LCD_HEIGHT 65

#define LCDFLG_ADC 1
#define LCDFLG_DISPLAY_ON 2
#define LCDFLG_REF_VOLTAGE_SEL 4
#define LCDFLG_SET_STATIC_IND_MODE 8

struct lcd {
  uint8 ddram[9 * 132];
  int flags;
  int page, col;
};

uint32 lcd_read(struct lcd *lcd, uint32 adr);
void lcd_write(struct lcd *lcd, uint32 adr, uint32 val);
struct lcd *create_lcd(void);
void free_lcd(struct lcd *lcd);

int lcd_get_pixel(struct lcd *lcd, int x, int y);
void lcd_print_small(struct lcd *lcd, FILE *fp);

#endif
